package com.hzya.frame.plugin.lets.dingtalk.callback.service.impl;

import cn.hutool.core.lang.Assert;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.plugin.lets.dingtalk.callback.service.CallBackService;
import com.hzya.frame.plugin.lets.dingtalk.vo.DingCallbackCrypto;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Map;

@Service("callBackService")
public class CallBackServiceImpl implements CallBackService {

    protected static Logger logger = LogManager.getLogger(CallBackServiceImpl.class);

    @Value("${DING.call_back_token}")
    private String token;
    @Value("${DING.call_back_aes_key}")
    private String aes_key;
    @Value("${DING.APPKEY}")
    private String corpId;

    @Override
    public Map<String, String> saveDingTalkCallBackRes(String msg_signature, String timeStamp, String nonce, JSONObject json) {
        logger.info("=============================================================================================================================钉钉回调执行快开始》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》》");
        try {

            // 1. 从http请求中获取加解密参数
            // 2. 使用加解密类型
            // 2、调用订阅事件接口订阅的事件为企业级事件推送，此时OWNER_KEY为：开发者后台应用的Client ID（原企业内部应用 appKey )
            //token、ase_key均为钉钉开放平台后台管理，应用设置的事件订阅,http推送中设置的参数。
            DingCallbackCrypto callbackCrypto = new DingCallbackCrypto(token, aes_key, corpId);
            String encryptMsg = json.getString("encrypt");
            String decryptMsg = callbackCrypto.getDecryptMsg(msg_signature, timeStamp, nonce, encryptMsg);

            // 3. 反序列化回调事件json数据
            JSONObject eventJson = JSON.parseObject(decryptMsg);

            String eventType = eventJson.getString("EventType");

            // 4. 根据EventType分类处理
            if ("check_url".equals(eventType)) {
                // 测试回调url的正确性
                logger.info("测试回调url的正确性");
            } else if ("bpms_instance_change".equals(eventType)) {
                // 处理通讯录用户增加事件
                logger.info("发生了：" + eventType + "事件");
            } else {
                // 添加其他已注册的
                logger.info("发生了：" + eventType + "事件");
            }

            // 5. 返回success的加密数据
            Map<String, String> successMap = callbackCrypto.getEncryptedMap("success");
            logger.info("=============================================================================================================================钉钉回调执行结束《《《《《《《《《《《《《《《《《《《《《《《《《《《《《《《《《");
            return successMap;
        }catch (Exception e){
            logger.error("execute", e);
            Assert.state(false, "excute:{}", e);
        }
        return null;
    }
}
